;==========================================================================
;  Anwendung:		Kopierprogram fr RAM und ROM
;
;	Autor:			E.Mueller
;
;	erstellt:		?
;	gendert:		22.03.2008
;       
;	Prozessor:		U883
;	Takt:				8 MHz
;	geeignet fr:	JU+TE mit 4K Betriebssystem
;
;==========================================================================
;f. Arnold-Assembler
;AS-Funktionen
hi              function x,(x>>8)&255
lo              function x, x&255

	cpu	z8601
	assume RP:0C0h		; keine Optimierung !
RP	EQU	0FDH		; Registerpointer
;==========================================================================

	org 0F800h
	
Anfang:
	push	rp
	srp	#040h
	ld	r15,#lo(Z_Bild1)
	ld	r14,#hi(Z_Bild1)
	call	Baue_Bild
	;Kopierziel wirklich im RAM? (ab 08000h)
	tcm	028h,#080h
	jr	Z,.m1
	ld	r15,#lo(Z_Bild3)
	ld	r14,#hi(Z_Bild3)
	call	Baue_Bild
	ld	r15,#lo(Z_Bild5)
	ld	r14,#hi(Z_Bild5)
	call	Baue_Bild
	pop	rp
	call	00C1Dh	;Tastenabfrage
	jr	Anfang	
.m1	pop	rp
	call	00C1Dh	;Tastenabfrage
	ld	022h,05Ah
	cp	022h,#04Ah	;J
	jr	Z,Kop_start
	pop	rp
	ret

Kop_start:
	di				;Los gehts
	push rp
	srp #020h
	incw	rr6		;Damit auch die letzte Postion kopiert wird !
starten:
	ldc r0,@rr4
	lde @rr8,r0
	;Alles i.O.?
	push	r1
	ldc	r1,@rr8
	cp	r1,r0
	jr	z,.m1
	;Fehler bei Kopieren
	pop	r1
	pop rp
	ei
	push	rp
	srp	#040h
	ld	r15,#lo(Z_Bild4)
	ld	r14,#hi(Z_Bild4)
	call	Baue_Bild
	ld	r15,#lo(Z_Bild5)
	ld	r14,#hi(Z_Bild5)
	call	Baue_Bild
	pop	rp
	call	00C1Dh	;Tastenabfrage
	jp	Anfang
.m1	pop	r1
	incw rr4
	incw rr8
	cp r6,r4
	jr nz,starten	;oberer Teil nicht 0, dann weiter
	cp r7,r5
	jr nz,starten	;unterer Teil nicht 0, dann weiter
	pop rp
	ei
	push	rp
	srp	#040h
	ld	r15,#lo(Z_Bild2)
	ld	r14,#hi(Z_Bild2)
	call	Baue_Bild
	pop	rp
	call	00C1Dh	;Tastenabfrage
	ld	022h,05Ah
	cp	022h,#04Ah	;J
	jp	Z,Anfang	
	ret

Baue_Bild:
	ldc	r13,@rr14
	cp	r13,#001h
	jr	z,BB_W1
	cp	r13,#002h
	jr	z,BB_W2
	cp	r13,#003h
	jr	z,BB_W3
	cp	r13,#004h
	jr	z,BB_W4
	cp	r13,#005h
	jr	z,BB_W5
	cp	r13,#006h
	jr	z,BB_WX
	;normales Zeichen
	ld	05Ah,r13
	call	00827h
BB_W0:
	incw	rr14	
	jr	Baue_Bild
BB_W1:
	call	008DDh	;Bildschirm lschen
	jr		BB_W0
BB_W2:
	call	00ACEh	;neue Zeile
	jr		BB_W0
BB_W3:
	ld	02Ah,#024h	;Quelle von
	call	Adresse_eingeben
	jr		BB_W0
BB_W4:
	ld	02Ah,#026h	;Quelle bis
	call	Adresse_eingeben
	jr		BB_W0
BB_W5:
	ld	02Ah,#028h	;Ziel von
	call	Adresse_eingeben
	jr		BB_W0
BB_WX:
	ret

Z_Bild1:	
	;001h Bildschirm lschen
	;002h neue Zeile
	;003h Quelle von
	;004h Quelle bis
	;005h Ziel von
	;006h Ende
	db	001h
	db "RAM-KOPIERER"
	db	002h,002h
	db "QUELLE"
	db	002h
	db "VON: "
	db 003h,002h
	db "BIS: "
	db 004h,002h
	db "ZIEL"
	db	002h
	db "VON: "
	db 005h,002h
	db "BEREIT(J/N)?"
	db	006h

Z_Bild2:	
	db	001h
	db "  KOPIEREN"
	db 002h
	db "   FERTIG!"
	db 002h, 002h
	db "NOCHMAL(J/N)?"
	db 006h

Z_Bild3:	
	db	001h
	db " ZIEL LIEGT"
	db 002h
	db "NICHT IM RAM"
	db 002h
	db " AB ADRESSE"
	db 002h
	db " %8000 (HEX)"
	db 006h

Z_Bild4:	
	db	001h
	db " FEHLER BEIM"
	db 002h
	db "  KOPIEREN!"
	db 006h
	
Z_Bild5:
	db 002h,002h
	db "  BELIEBIGE"
	db 002h
	db "    TASTE"
	db 002h
	db "  DRUECKEN!"
	db 006h
	
Taste_erkannt:
	ld	05Ah,022h		;Darstellen	
	call	00827h
	ld	@02Fh,020h	;Lade Zeichen in Zwischenspeicher
	dec	02Fh			;Stellenzeiger Zwischenspeicher
	djnz	r3,Tastenabfrage
	rl	02Eh	;1.Stelle
	rl	02Eh
	rl	02Eh
	rl	02Eh
	and	02Eh,#0F0h
	rl	02Ch	;3.Stelle
	rl	02Ch
	rl	02Ch
	rl	02Ch
	and	02Ch,#0F0h
	add	02Eh,02Dh	;1.& 2.Stelle zusammenfhren
	add	02Ch,02Bh	;3.& 4.Stelle zusammenfhren
	ld	@02Ah,02Eh	;oberer Adressteil
	inc	02Ah
	ld	@02Ah,02Ch	;unterer Adressteil
	pop	rp
	ret	

Adresse_eingeben:
	push	rp
	srp	#020h
	ld	023h,#004h		;Stellenzhler auf 4
	ld	02Fh,#02Eh		;Stellenzeiger
Tastenabfrage:
	call	00C1Dh	;Tastenabfrage
	ld	022h,05Ah
	ld	020h,#000h
	cp	022h,#030h	;0
	jp	Z,Taste_erkannt
	ld	020h,#001h
	cp	022h,#031h	;1
	jp	Z,Taste_erkannt
	ld	020h,#002h
	cp	022h,#032h	;2
	jp	Z,Taste_erkannt
	ld	020h,#003h
	cp	022h,#033h	;3
	jp	Z,Taste_erkannt
	ld	020h,#004h
	cp	022h,#034h	;4
	jp	Z,Taste_erkannt
	ld	020h,#005h
	cp	022h,#035h	;5
	jp	Z,Taste_erkannt
	ld	020h,#006h
	cp	022h,#036h	;6
	jp	Z,Taste_erkannt
	ld	020h,#007h
	cp	022h,#037h	;7
	jp	Z,Taste_erkannt
	ld	020h,#008h
	cp	022h,#038h	;8
	jp	Z,Taste_erkannt
	ld	020h,#009h
	cp	022h,#039h	;9
	jp	Z,Taste_erkannt
	ld	020h,#00Ah
	cp	022h,#041h	;A
	jp	Z,Taste_erkannt
	ld	020h,#00Bh
	cp	022h,#042h	;B
	jp	Z,Taste_erkannt
	ld	020h,#00Ch
	cp	022h,#043h	;C
	jp	Z,Taste_erkannt
	ld	020h,#00Dh
	cp	022h,#044h	;D
	jp	Z,Taste_erkannt
	ld	020h,#00Eh
	cp	022h,#045h	;E
	jp	Z,Taste_erkannt
	ld	020h,#00Fh
	cp	022h,#046h	;F
	jp	Z,Taste_erkannt
	jp	Tastenabfrage

	end
