;------------------------------------------------------------------------------
; TINY ES40 EPROM-Bank
; (c) V. Pohlers 2021
;------------------------------------------------------------------------------
; Zusammenstellung Bankinhalt, erzeugt den ROM
; 21.08.2021, letzte nderung 
;------------------------------------------------------------------------------
; bei nderungen in dieser Datei unbedingt 'make depend' starten!
;------------------------------------------------------------------------------

;        cpu 96C141			; Mikrocontroller mit groem Adressbereich
;        maxmode on			; der Z8 reicht hier nicht.
					; leider little endian
	
	cpu 80C251			; geht mit bigendian :-)
        BIGENDIAN on

	MACEXP  off

; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

;AS-Funktionen
hi              function x,(x>>8)&255
lo              function x, x&255
x_align	function x, (($+x-1)/x)*x

myalign	macro	size
	org	x_align(size)
	endm

; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; MACRO a d d f i l e
;
	;addFile filename, aadr, [eadr], [sadr], typ, name, kommentar
;
;filename mit Pfad
;eadr kann bei ungepackten Daten leer bleiben (dann = aadr+filelength)
;sadr kann leer bleiben (dann = aadr)
;typ = Dateityp (B = Tiny-MPBASIC, M = MC-Binary)
;Name = xx Zeichen
;Kommentar = xx 13 Zeichen
;
; align	100h verschwendet etwas Speicher, aber ist vermutlich leichter zu handlen
; fileXname als Dummy anlegen

addFile	macro	fileXname,aadr,eadr,sadr,typ,name

		align	20h	
		;align	100h	

pos	eval	$

	if	"eadr"<>""
eaddr	eval	eadr
	else
eaddr	eval	aadr+file_bis-file_von
	endif
	if	"sadr"<>""
saddr	eval	sadr
	else
saddr	eval	aadr
	endif

len 	eval	eaddr-aadr+1

packed	eval	0
	if STRSTR(fileXname,".pck") > 0
packed	eval	80h
eaddr 	eval	0
	endif
	
		; Header
		db	0FAH,0FAH			; 2 magic marker FlAsH
		dw	aadr, eaddr, saddr		; 6
		;;db	hi(aadr), lo(aadr)
		;;db	hi(eaddr), lo(eaddr)
		;;db	hi(saddr), lo(saddr)
		db	packed
		db	6 dup(0)			; reserviert
		db	typ				; 1
		db	upstring(substr(name+"                ",0,16))	; 16

		; file
		align	20h			; align knnte entfallen; Header ist 20h lang
file_von
		BINCLUDE  fileXname
file_bis
		MESSAGE "\{pos}h: aadr, \{eaddr}h, \{saddr}h, typ, "+name+", \{len}, "+fileXname

		endm

;------------------------------------------------------------------------------


	org	0000h
	binclude	U883_MME_BAS.bin
	org	0800h
	binclude	es_4k_1.bin

	org	1000h
	binclude	bank0.bin
	align	20h
	addFile "Software/basic2k/grafiklib_fca0.bin.pck", 0FCA0h, 0FCFFh, 000h, 'M', "Grafikbibl" 
	addFile "Software/basic2k/turm_von_hanoi.bin.pck", 0E000h, 0E7F1h, 000h, 'B', "Turm Hanoi" 
	align	20h
free eval 1800h-$	
	message "frei \{$}h-17FFh = \{free}"
	org	1800h
	binclude	"Software/volker/baserw2k.bin"

	align	20h
	addFile "Software/sonstige/othello.bin.pck", 0E000h, 0EB60h, 000h, 'B', "Othello" 
	align	20h
free eval 2000h-$	
	message "frei \{$}h-1FFFh = \{free}"

	org 	2000h
	binclude	es_4k_2-rb.bin

;------------------------------------------------------------------------------

	org	2800h

	;addFile filename, aadr, [eadr], [sadr], typ, name
	;Packen - Endung pck ergnzen!

	;bei jtc -> include file.bin.inc
	;sonst addFile "Software/basic2k/autocross.bin", 0E000h, 0E31Fh, 000h, 'B', "Autocross" 

 
;	addFile "Software/basic2k/autocross.bin.pck", 0E000h, 0E31Fh, 000h, 'B', "Autocross" 
	addFile "Software/basic2k/autocross_plus.bin.pck", 0E000h, 0E33Dh, 000h, 'B', "Autocross+" 
	addFile "Software/basic2k/ein_mal_eins.bin.pck", 0E000h, 0E386h, 000h, 'B', "EinMalEins" 
;; grafiklib oben
;;	addFile "Software/basic2k/grafiklib_fca0.bin.pck", 0FCA0h, 0FCFFh, 000h, 'M', "Grafikbibl" 
;	addFile "Software/basic2k/grafiktest.bin.pck", 0E000h, 0E090h, 000h, 'B', "Grafiktest" 
;	addFile "Software/basic2k/hase_wolf.bin.pck", 0E000h, 0E351h, 000h, 'B', "HaseWolf" 
	addFile "Software/basic2k/hase_wolf_plus.bin.pck", 0E000h, 0E389h, 000h, 'B', "HaseWolf+" 
;	addFile "Software/basic2k/kleines1x1.bin.pck", 0E000h, 0E19Ch, 000h, 'B', "Kleines 1x1" 
;	addFile "Software/basic2k/kreisberechnung.bin.pck", 0E000h, 0E06Bh, 000h, 'B', "Kreisberech" 
	addFile "Software/basic2k/kurzzeitwecker.bin.pck", 0E000h, 0E0E5h, 000h, 'B', "Kurzwecker" 
;	addFile "Software/basic2k/landstrasse.bin.pck", 0E000h, 0E373h, 000h, 'B', "Landstrasse" 
;;	addFile "Software/basic2k/malfix.bin.pck", 0E000h, 0E227h, 000h, 'B', "Mal-Fix" 
	addFile "Software/volker/malfix.bin.pck", 0E000h, 0E227h, 000h, 'B', "Mal-Fix" 	; fr baserw2k
;	addFile "Software/basic2k/mastermind.bin.pck", 0E000h, 0E338h, 000h, 'B', "MasterMind" 
;	addFile "Software/basic2k/melodie.bin.pck", 0E000h, 0E084h, 000h, 'B', "Melodie" 
;	addFile "Software/basic2k/mondlandung_v1.bin.pck", 0E000h, 0E0F3h, 000h, 'B', "Mondland. 1" 
;	addFile "Software/basic2k/mondlandung_v2.bin.pck", 0E000h, 0E1F3h, 000h, 'B', "Mondland. 2" 
	addFile "Software/basic2k/monophon.bin.pck", 0E000h, 0E1C2h, 000h, 'B', "Monophon" 
;;	addFile "Software/basic2k/pasch.bin.pck", 0E000h, 0ECB9h, 000h, 'B', "Pasch" 
;	addFile "Software/basic2k/primzahlen.bin.pck", 0E000h, 0E25Fh, 000h, 'B', "Primzahlen" 
;	addFile "Software/basic2k/quadratwurzel.bin.pck", 0E000h, 0E085h, 000h, 'B', "SQR" 
;	addFile "Software/basic2k/reaktionstest_v1.bin.pck", 0E000h, 0E0FCh, 000h, 'B', "Reaktion V1" 
;	addFile "Software/basic2k/reaktionstest_v2.bin.pck", 0E000h, 0E3F9h, 000h, 'B', "Reaktion V2" 
;	addFile "Software/basic2k/roemische_zahlen.bin.pck", 0E000h, 0E3C0h, 000h, 'B', "Roem.Zahlen" 
;	addFile "Software/basic2k/schiebepuzzle.bin.pck", 0E000h, 0E3FEh, 000h, 'B', "Schiebepuzz" 
	addFile "Software/basic2k/schiebepuzzle_plus.bin.pck", 0E000h, 0E446h, 000h, 'B', "Schiebepu.+" 
	addFile "Software/basic2k/solohalma.bin.pck", 0E000h, 0E3F5h, 000h, 'B', "Solo-Halma" 
;; hanoi nach oben gebracht
;;	addFile "Software/basic2k/turm_von_hanoi.bin.pck", 0E000h, 0E7F1h, 000h, 'B', "Turm Hanoi" 
	addFile "Software/basic2k/wochentag.bin.pck", 0E000h, 0E1C4h, 000h, 'B', "Wochentag" 
	addFile "Software/basic2k/zahlenraten.bin.pck", 0E000h, 0E0F0h, 000h, 'B', "Zahlenraten" 

 
;	addFile "Software/jute/c520d_mess.bin.pck", 0E000h, 0E3A7h, 000h, 'B', "C520D MESS" 
;	addFile "Software/jute/c520d_oszi.bin.pck", 0E000h, 0E3AFh, 000h, 'B', "C520D OSZI" 
;	addFile "Software/jute/eprommer_4k.bin.pck", 0E000h, 0E2AFh, 0E000h, 'B', "EPROMMER 4K" 
	addFile "Software/jute/forth_4k.bin.pck", 0E000h, 0F49Fh, 0E000h, 'M', "Forth" 
;	addFile "Software/jute/Lauflicht.bin.pck", 0E000h, 0E0BAh, 000h, 'B', "Lauflicht" 
;	addFile "Software/jute/oszi.bin.pck", 0E000h, 0E1FFh, 000h, 'B', "OSZI" 
;	addFile "Software/jute/rechner+mtb.bin.pck", 0E000h, 0E3FFh, 0E000h, 'M', "Rechner+MTB" 
;	addFile "Software/jute/s3004.bin.pck", 0F900h, 0FBFFh, 000h, 'M', "S3004" 
;	addFile "Software/jute/u2716-handler.bin.pck", 0E000h, 0E3F2h, 000h, 'B', "u2716-handl" 

;	addFile "Software/sonstige/kopieren.bin"	, 0F800h, , , 'M', "KOPIEREN" 	; E.Mueller
	addFile "Software/sonstige/t2verb-as.bin.pck"	, 0F800h, , , 'M', "TOR2" 	; E.Mueller
 
;	addFile "Software/sonstige/ballern.bin.pck", 0E000h, 0E519h, 000h, 'B', "BALLERN" 
;	addFile "Software/sonstige/SPACE4.bin"		, 0E000h, , , 'M', "SPACE" 	; TH. RACKWITZ 
;	addFile "Software/sonstige/bandit.bin.pck", 0E000h, 0E671h, 000h, 'B', "BANDIT" 
;	addFile "Software/sonstige/lauf_PW.bin.pck", 0E000h, 0E156h, 0E000h, 'M', "lauf_PW" 

;; othello nach oben gepackt
;;	addFile "Software/sonstige/othello.bin.pck", 0E000h, 0EB60h, 000h, 'B', "Othello" 
	addFile "Software/sonstige/Steine.bin.pck", 0E000h, 0FBFFh, 0E000h, 'M', "Steine" 
;
	addFile "Software/volker/z8671basic_es1988.bin.pck", 08000h, , 08000h, 'M', "Z8671BASIC" 	; Zilog, VP

;------------------------------------------------------------------------------

	if	$>=05FFFh
		WARNING "ROM-Kapazitt berschritten!"
	endif

	align 20h
free eval 6000h-$	
	message "frei \{$}h-5FFFh = \{free}"

	org	05FFFh
	db	42

        end
